﻿Option Strict On
Option Infer On
Option Compare Binary
Option Explicit On
#Region "Imports"
Imports System
Imports System.IO
Imports System.Data
Imports System.Text
Imports Bines_Bastel_Stübchen.SteuernDataSet
Imports System.Data.OleDb
Imports Microsoft.Office.Interop
#End Region
Public Class Form1

    Private filterstring_datum As String = String.Empty

#Region "Form"
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.SteuernTableAdapter.Fill(Me.SteuernDataSet.Steuern)
        Summe()
    End Sub
    Private Sub Form_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Me.SuspendLayout()
        With Me.Controls
            While .Count > 0 : .Item(.Count - 1).Dispose() : End While
        End With
    End Sub
#End Region
#Region "Datum"
    Private Sub btn_Datum_Click(sender As Object, e As EventArgs) Handles btn_Datum.Click
        setze_minmaxdatum()
        Summe()
    End Sub
    Private Sub ermittel_minmaxdatum()
        If Me.SteuernDataSet.Steuern.Rows.Count = 0 Then
            With dtp_von
                .MinDate = Today
                .MaxDate = Today
            End With
            With dtp_bis
                .MinDate = Today
                .MaxDate = Today
            End With

            Return
        End If
        'Dim begDatum = SteuernDataSet.Steuern.Select(Function(x) x.Datum).Min
        'Dim endDatum = SteuernDataSet.Steuern.Select(Function(x) x.Datum).Max
        Dim col = Me.SteuernDataSet.Steuern.DatumColumn
        Dim expMin As String = String.Concat("Min(", col, ")")
        Dim expMax As String = String.Concat("Max(", col, ")")

        Dim begDatum As Date = CDate(Me.SteuernDataSet.Steuern.Compute(expMin, ""))
        Dim endDatum As Date = CDate(Me.SteuernDataSet.Steuern.Compute(expMax, ""))

        With dtp_von
            .MinDate = begDatum
            .MaxDate = endDatum
        End With

        With dtp_bis
            .MinDate = begDatum
            .MaxDate = endDatum
        End With
    End Sub
    Private Sub setze_minmaxdatum()
        With dtp_von
            .Value = .MinDate
        End With
        With dtp_bis
            .Value = .MaxDate
        End With
    End Sub
    Private Sub setze_letzten_Tag()
        With dtp_von
            .Value = .MaxDate
        End With
        With dtp_bis
            .Value = .MaxDate
        End With
    End Sub
    Private Sub dtp_ValueChanged(sender As Object, e As EventArgs) Handles dtp_von.ValueChanged, dtp_bis.ValueChanged
        alleFilter()
    End Sub
    Private Function Datum_erstellen() As String
        If dtp_von.Value > dtp_bis.Value Then
            Dim tmp1 As Date = dtp_von.Value
            Dim tmp2 As Date = dtp_bis.Value
            dtp_von.Value = tmp2
            dtp_bis.Value = tmp1
        End If
        'Dim _Beginn = dtp_von.Value.Date
        'Dim _Ende = dtp_bis.Value.Date.AddDays(1).AddMilliseconds(-1)

        Dim _Beginn As New DateTime(dtp_von.Value.Year, dtp_von.Value.Month, dtp_von.Value.Day, 0, 0, 0, 0)
        Dim _Ende As New DateTime(dtp_bis.Value.Year, dtp_bis.Value.Month, dtp_bis.Value.Day, 23, 59, 59, 999)
        filterstring_datum = String.Format("[{0}] >= '{1}' AND [{0}] <= '{2}'", "Datum", _Beginn, _Ende)

        Return filterstring_datum
    End Function
#End Region
#Region "alle Filter verbinden"
    Private Sub alleFilter()
        Dim sb As New StringBuilder
        filterstring_datum = Datum_erstellen()
        sb.AppendFormat("{0}", filterstring_datum)
        'SteuernBindingSource.Filter = Datum_erstellen() 'neu
        SteuernBindingSource.Filter = sb.ToString
        sb.Length = 0 : sb = Nothing
        'Dim SumOfAllValuesBetweenTwoDates = SteuernDataSet.Steuern.Where(Function(x) x.DatumColumn >= dtp_von.Value.Date AndAlso x.DatumColumn <= dtp_bis.Value.Date).Select(Function(y) y.Versandkosten).Sum


    End Sub
#End Region
#Region "Kalender"
    Private Sub Kalender_DateChanged(sender As Object, e As DateRangeEventArgs) Handles Kalender.DateChanged
        tbx_Datum.Text = Kalender.SelectionRange.Start.ToShortDateString()
    End Sub
#End Region
#Region "export"
    Private Sub btn_export_Click_1(sender As Object, e As EventArgs) Handles btn_export.Click

        '    Dim xlapp As New Excel.Application
        '    If xlapp Is Nothing Then
        '        MessageBox.Show("Excel ist nicht installiert!")
        '        Return
        '    End If
        '    Dim xlwb As Excel.Workbook
        '    Dim xlws As Excel.Worksheet
        '    Dim c, r, k As Integer

        '    xlwb = xlapp.Workbooks.Add()
        '    xlws = DirectCast(xlwb.Sheets(1), Excel.Worksheet) 'Konvertierung eines sheets in ein excel.worksheet und Deklarierung an das xlws Objekt
        '    xlws.Name = "Bestandsverzeichnis"
        '    k = 1 'Zeile der Spaltenüberschriften
        '    c = 1 'Startreihe der Werte
        '    r = 2 'Startzeile der Werte
        '    xlapp.Visible = True
        '    'Spaltenüberschriften
        '    For Each column As DataGridViewColumn In DGV.Columns
        '        Dim Header As String = column.HeaderText
        '        xlws.Cells(1, k) = Header
        '        k += 1
        '    Next
        '    'Feldwerte
        '    For Each row As DataGridViewRow In DGV.Rows
        '        For Each column As DataGridViewColumn In DGV.Columns
        '            'für jede Spalte in jeder Reihe wird der Wert des Feldes an Excel übergeben
        '            Dim Value As String = row.Cells(column.Name).Value.ToString
        '            xlws.Cells(r, c) = Value
        '            c += 1
        '        Next
        '        r += 1
        '        c = 1
        '    Next
    End Sub
#End Region
#Region "Spaltensummen"
    Private Sub DGV_CellContentClick_1(sender As Object, e As DataGridViewCellEventArgs) Handles DGV.CellContentClick
        Summe()
    End Sub
    Private Sub Summe()
        Dim summe1 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(4).Value IsNot DBNull.Value Then
                summe1 += Convert.ToDouble(DGV.Rows(i).Cells(4).Value)
            End If
        Next
        tbx_summe1.Text = summe1.ToString("C")
        '----------------------------------------------------------------------
        Dim summe2 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(5).Value IsNot DBNull.Value Then
                summe2 += Convert.ToDouble(DGV.Rows(i).Cells(5).Value)
            End If
        Next
        tbx_summe2.Text = summe2.ToString("C")
        '----------------------------------------------------------------------
        Dim summe3 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(6).Value IsNot DBNull.Value Then
                summe3 += Convert.ToDouble(DGV.Rows(i).Cells(6).Value)
            End If
        Next
        tbx_summe3.Text = summe3.ToString("C")
        '----------------------------------------------------------------------
        Dim summe4 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(7).Value IsNot DBNull.Value Then
                summe4 += Convert.ToDouble(DGV.Rows(i).Cells(7).Value)
            End If
        Next
        tbx_summe4.Text = summe4.ToString("C")
        '----------------------------------------------------------------------
        Dim summe5 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(9).Value IsNot DBNull.Value Then
                summe5 += Convert.ToDouble(DGV.Rows(i).Cells(9).Value)
            End If
        Next
        tbx_summe5.Text = summe5.ToString("C")
        '----------------------------------------------------------------------

        Dim summe6 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(10).Value IsNot DBNull.Value Then
                summe6 += Convert.ToDouble(DGV.Rows(i).Cells(10).Value)
            End If
        Next
        tbx_summe6.Text = summe6.ToString("C")
        '----------------------------------------------------------------------
        Dim summe7 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(11).Value IsNot DBNull.Value Then
                summe7 += Convert.ToDouble(DGV.Rows(i).Cells(11).Value)
            End If
        Next
        tbx_summe7.Text = summe7.ToString("C")
        '----------------------------------------------------------------------
        Dim summe8 As Double = 0
        For i As Integer = 0 To DGV.Rows.Count - 1
            If DGV.Rows(i).Cells(12).Value IsNot DBNull.Value Then
                summe8 += Convert.ToDouble(DGV.Rows(i).Cells(12).Value)
            End If
        Next
        tbx_summe8.Text = summe8.ToString("C")
    End Sub
#End Region
#Region "Diagramm"
    Private Sub tbx_diagramm_Click(sender As Object, e As EventArgs) Handles tbx_diagramm.Click
        Form2.Show()
    End Sub
#End Region
#Region "Cellclick"
    Private Sub DGV_CellContentClick(sender As Object, e As DataGridViewCellEventArgs)
        Summe()
    End Sub
#End Region
#Region "anlegen, bearbeiten, entfernen, übernehmen, Abbruch"
    Private Sub btn_anlegen_Click(sender As Object, e As EventArgs) Handles btn_anlegen.Click
        Me.Validate()
        Me.SteuernBindingSource.AddNew()
    End Sub
    Private Sub btn_bearbeiten_Click(sender As Object, e As EventArgs) Handles btn_bearbeiten.Click
        SteuernBindingSource.EndEdit()
    End Sub
    Private Sub btn_entfernen_Click(sender As Object, e As EventArgs) Handles btn_entfernen.Click
        Dim i As Integer
        SteuernBindingSource.RemoveAt(DGV.SelectedRows(i).Index)
    End Sub
    Private Sub btn_übernehmen_Click(sender As Object, e As EventArgs) Handles btn_übernehmen.Click
        Me.Validate()
        Me.SteuernBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.SteuernDataSet)
        DGV.Refresh()
        Summe()
    End Sub
    Private Sub btn_Abbruch_Click(sender As Object, e As EventArgs) Handles btn_Abbruch.Click
        Me.SteuernBindingSource.CancelEdit()
        DGV.Refresh()
    End Sub
#End Region




End Class
